function [D,PSSP]=TRmusicUWB(m,d,X,f_tap,f_centrale,tau,Pn,zmin,val_x_ini)

% X  una matrice di d righe(d=numero delle sorgenti)
% d=numero di sorgenti

Rmatr = creaRmatrUWB(m,f_centrale,val_x_ini);% m x 2

Gmatrix = zeros(m,d);

gd = zeros(m,1);

c=3e8;

for p=1:length(f_tap)

for j=1:d

    for i=1:m
        
        gd(i,:) = creaGreenlambda(f_tap(p),Rmatr(i,:),X(j,:),val_x_ini);  
    
    end
     
    Gmatrix(:,j) = gd;
     
end

% matrice diagonale delle potenze dei segnali
% ipotizzando che possiedano una PSD ideale.
reflectCoeffs=eye(d);
for(k=1:d)
    reflectCoeffs(k,k)=tau(k);
end
K=Gmatrix*reflectCoeffs*conj(Gmatrix');% mxm

rumore=sqrt(Pn/2)*(randn(m,m)+i*randn(m,m));

H=K+rumore;

T=conj(H')*H;

[U,D,V]=svd(T);

[U1,D1,V1]=svd(H);

passo=(c/max(f_tap))/4;

for k=1:100

    x=k*passo;
    
    for n=1:100
    
    z=n*passo+zmin;
    
        for l=1:m

        gp(l,1) = creaGreenlambda(f_tap(p),Rmatr(l,:),[x z],val_x_ini);   
    
        end

        somma=0;

        for f=d+1:m

        somma=somma+abs(gp'*U1(:,f))^2;

        end
        
        den(k,n,p)=somma;
        
        pssp(k,n)=1/somma;
    
    end
    
end

end 

passo=(c/max(f_tap))/4;
 
for k=1:100
 
     x=k*passo;
     
     for n=1:100
     
     z=n*passo;
     
     psspINT(k,n)=1/sum(den(k,n,:));

     end
     
end

PSSP=10*log10(psspINT);

[asseX,asseZ]= meshgrid([1:100]*passo,[1:100]*passo);

meshc(asseX,asseZ,PSSP);


